function getCurrentCartAsSeekaCart() {
    return {
        products: [
            {
                productIdentifier: '119933', // required
                variantIdentifier: '1245663433',
                sku: 'sku_product_4',
                lineItemIdentifier: 'cc8bac2979ea4f5c9a2e8f25fa7ea6d1',
                productName: 'Super awesome product', // required
                variantName: 'Super variant - size medium',
                categoryName: 'T shirts',
                brandName: 'Tshirts r us',
                currencyCode: 'USD', // required when unitPrice is provided
                unitPrice: 84.33, // required for order, init checkout, add payment method
                quantity: 1 // required
            },
            {
                productIdentifier: '442121',
                variantIdentifier: '166544353',
                sku: 'sku_product_12',
                lineItemIdentifier: '8c2d8599bf3c4d7ea6ffba40ea8c8784',
                productName: 'Very cool product',
                variantName: 'Cool variant - size large',
                categoryName: 'Bracelets',
                brandName: 'Bracelets r us',
                unitPrice: 5,
                quantity: 2
            }
        ],
        orderIdentifier: '3075b174947347388e5c13a7df87c341', // required for dedupe
        currencyCode: 'USD', // required for order, init checkout, add payment method
        totalPrice: 193.53, // required for order
        totalTax: 87.1,
        totalShippingPrice: 12.10
    }
}

function getCurrentUserAsSeekaIdentity() {
    var identity = {
        firstName: ['John'],
        lastName: ['Smith'],
        email: ['john.smith@companydomain123.com'],
        phone: ['+61400111222'],
    };

    return identity;
}

// This nethod should be called each time new info is provided by the user.
// either by the user progressing through the funnel or when user logs in etc.
function trackIdentity() {
    // https://developers.seeka.co/sdk/js/reference/spec/identity/classes/IdentitySdk#mergeprofile()
    var payload = getCurrentUserAsSeekaIdentity();

    // Complete identifiers model - https://developers.seeka.co/sdk/js/reference/spec/identity/seeka/interfaces/PersonIdentifiers
    payload.address = [
        {
            addressLine1: '123 Fake St',
            country: 'Australia', // either country or countryCode can be provided
            countryCode: 'AU', // either country or countryCode can be provided
            postcode: '4218',
            state: 'Queensland', // either state or stateCode can be provided
            stateCode: 'QLD', // either state or stateCode can be provided
        }
    ];

    Converge.identity.mergeProfile(payload);
}

function trackAddToCart() {
    // https://developers.seeka.co/sdk/js/reference/spec/track/classes/TrackingSdk#addtocart()
    var payload = getCurrentCartAsSeekaCart().products[0];
    Converge.track.addToCart(payload);
}

function trackAddPaymentMethod() {
    // https://developers.seeka.co/sdk/js/reference/spec/track/classes/TrackingSdk#addpaymentmethod()
    var payload = getCurrentCartAsSeekaCart();
    payload.paymentMethodName = 'Credit card';
    Converge.track.addPaymentMethod(payload);

    // Track identity traits that are known
    trackIdentity()
}

function trackInitiateCheckout() {
    // https://developers.seeka.co/sdk/js/reference/spec/track/classes/TrackingSdk#initiatecheckout()
    var payload = getCurrentCartAsSeekaCart();
    Converge.track.initiateCheckout(payload);

    // Track identity traits that are known
    trackIdentity()
}

function trackCustom() {
    // https://developers.seeka.co/sdk/js/reference/spec/track/classes/TrackingSdk#custom()
    Converge.track.custom('My event name');
}

function trackOrder() {
    // https://developers.seeka.co/sdk/js/reference/spec/track/classes/TrackingSdk#order()
    var payload = getCurrentCartAsSeekaCart();
    Converge.track.order(payload);

    // Track identity traits that are known
    trackIdentity()
}

function trackViewProduct() {
    // https://developers.seeka.co/sdk/js/reference/spec/track/classes/TrackingSdk#viewproduct()
    var payload = getCurrentCartAsSeekaCart().products[0];
    Converge.track.viewProduct(payload);
}